package lcsb.mapviewer.api.mesh;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import lcsb.mapviewer.annotation.data.MeSH;
import lcsb.mapviewer.annotation.services.MeSHParser;
import lcsb.mapviewer.annotation.services.annotators.AnnotatorException;
import lcsb.mapviewer.api.BaseRestImpl;
import lcsb.mapviewer.api.ObjectNotFoundException;
import lcsb.mapviewer.model.map.MiriamData;
import lcsb.mapviewer.model.map.MiriamType;

@Transactional(value = "txManager")
public class MeshRestImpl extends BaseRestImpl {

  /**
   * Default class logger.
   */
  @SuppressWarnings("unused")
  private Logger logger = Logger.getLogger(MeshRestImpl.class);

  @Autowired
  private MeSHParser meSHParser;

  public Map<String, Object> getMesh(String token, String id) throws AnnotatorException, ObjectNotFoundException {

    MeSH mesh = meSHParser.getMeSH(new MiriamData(MiriamType.MESH_2012, id));
    if (mesh == null) {
      throw new ObjectNotFoundException("Object not found: " + id);
    }
    Map<String, Object> result = new HashMap<>();
    result.put("name", mesh.getName());
    result.put("id", mesh.getMeSHId());
    result.put("description", mesh.getDescription());
    result.put("synonyms", mesh.getSynonyms());
    return result;
  }
}
